using Exferia_Aplicacion.General;
using Exferia_Aplicacion.Visualizacion;
using Exferia_Controles;
using Exferia_EntityFramework;
using Exferia_General;
using Exferia_KairosPRO._4_Vistas.Controladoras;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Windows.Forms;
using static Exferia_Aplicacion.General.Enumerados;

namespace Exferia_KairosPRO._4_Vistas
{
    public partial class P_Configuraciones : Exferia_Formularios.P_Base_Mantenimientos
    {
        #region Variables General
        private P_Configuraciones_Controladora g_obj_Controladora;

        private bool g_bol_ConstructorPantalla_Terminado_Correctamente = true;
        public PRV_OpcionesDetalle g_mdl_PRV_OpcionesDetalle = null;

        internal List<INTERNO_Permisos_Modelo> g_lst_INTERNO_Permisos_Modelo = null;

        //Variable paginador
        public Funciones_Paginador g_obj_Funciones_Paginador;
        private Timer g_timer_Paginar = new Timer();
        #endregion

        #region Objetos en pantalla
        //Exferia_CheckBox
        internal Exferia_CheckBox Exferia_CheckBox_SincronizacionAutomatica { get { return ex_chk_P_Configuraciones_SincronizacionAutomatica; } }
        internal Exferia_CheckBox Exferia_CheckBox_Sincronizacion_PorEventos { get { return ex_chk_P_Configuraciones_Sincronizacion_PorEventos; } }

        //Exferia_Label 
        internal Exferia_Label Exferia_Label_TipoDispositivo { get { return ex_lbl_P_Configuraciones_TipoDispositivo; } }
        internal Exferia_Label Exferia_Label_TiempoEsperaPantallaFichaje { get { return ex_lbl_P_Configuracion_TiempoEsperaPantallaFichaje; } }
        internal Exferia_Label Exferia_Label_Cadencia_SincronizacionAutomatica { get { return ex_lbl_P_Configuraciones_Cadencia_SincronizacionAutomatica; } }
        internal Exferia_Label Exferia_Label_Tiempo_FichajeValido_Horas { get { return ex_lbl_P_Configuracion_Tiempo_FichajeValido_Horas; } }

        //Exferia_Paginador
        internal Exferia_Paginador Exferia_Paginador_Configuracion { get { return ex_Paginador; } }

        //Exferia_RadioButton
        internal Exferia_RadioButton Exferia_RadioButton_Oficina { get { return ex_rdb_P_Configuraciones_Oficina; } }
        internal Exferia_RadioButton Exferia_RadioButton_Mythos { get { return ex_rdb_P_Configuraciones_Mythos; } }
        internal Exferia_RadioButton Exferia_RadioButton_Particular { get { return ex_rdb_P_Configuraciones_Particular; } }

        //Exferia_TextBox
        internal Exferia_TextBox Exferia_TextBox_Cadencia_SincronizacionAutomatica { get { return ex_txt_P_Configuraciones_Cadencia_SincronizacionAutomatica; } }
        internal Exferia_TextBox Exferia_TextBox_TiempoEsperaPantallaFichaje { get { return ex_txt_P_Configuracion_TiempoEsperaPantallaFichaje; } }
        internal Exferia_TextBox Exferia_TextBox_Tiempo_FichajeValido_Horas { get { return ex_txt_P_Configuracion_Tiempo_FichajeValido_Horas; } }
        #endregion

        #region Constructor
        public P_Configuraciones(INTERNO_ValoresGenerales_Modelo _mdl_INTERNO_ValoresGenerales_Modelo, DateTime _dtt_FechaTrabajo, PRV_OpcionesDetalle _mdl_PRV_OpcionesDetalle)
        {
            InitializeComponent();

            Repintar.Empezar(this);

            CheckForIllegalCrossThreadCalls = false;

            //Comprobamos que el codigo cliente exista y este bien
            if (Variables.G_LNG_IDCLIENTE_LICENCIAVALIDADO.Equals(-1))
            {
                //Tendriamos que avisar y no dejar abrir la pantalla
                Mensajes.MostrarMensaje(Mensajes.G_STR_LICENCIA_VALIDACIONES_LICENCIANOESTAACTIVA);
                Salir_P_Base();
            }

            //Empresa seleccionada y fecha de trabajo ....................................................
            P_Base_ValoresGenerales = _mdl_INTERNO_ValoresGenerales_Modelo;
            P_Base_FechaTrabajo = _dtt_FechaTrabajo;

            //Instanciar Controladora
            g_obj_Controladora = new P_Configuraciones_Controladora(this);

            //Datos de Opciones detalle
            g_mdl_PRV_OpcionesDetalle = _mdl_PRV_OpcionesDetalle;

            //Buscar los Permisos
            g_lst_INTERNO_Permisos_Modelo = Datos_Generales.Permisos_Buscar(g_mdl_PRV_OpcionesDetalle.opcion);

            //Poner los botones que no se puedan poner bloqueados o solo de lectura
            ex_btn_P_Configuraciones_Borrar.Exferia_Button_Bloqueable = false;
            ex_btn_P_Configuraciones_Grabar.Exferia_Button_Bloqueable = false;

            //Mirar si hay que bloquear los controles, si solo puede ver los datos
            if ((P_Base_TipoAperturaPantalla != 0 && Datos_Generales.Permisos_Comprobar(g_mdl_PRV_OpcionesDetalle.opcion, g_lst_INTERNO_Permisos_Modelo, (int)G_ENUM_PERMISOS.Modificar, false)) == false)
            {
                //Bloqueo los Controles
                SoloLectura.Empezar(this, true);
            }

            //Titulo de la Pantalla ............................................................................
            P_Base_TituloPantalla = _mdl_PRV_OpcionesDetalle.descripcion_TituloMantenimiento;

            try
            {
                //Label con Empresa Seleccionada
                if (P_Base_ValoresGenerales != null)
                {
                    try
                    {
                        P_Base_Mantenimientos_InformacionEmpresaSeleccionada = P_Base_ValoresGenerales.str_Empresa_Descripcion + " - " +
                                                                "(" + P_Base_FechaTrabajo.ToString("dd/MM/yyyy") + ")";
                    }
                    catch (Exception ex)
                    {
                        //No se muestra mensaje pero se guarda en el log
                        Control_Errores.Errores_Log("", ex, nameof(P_Configuraciones) + "/" + nameof(P_Configuraciones));
                    }
                }
                //..................................................................................................................................

                //Bloquear pantalla hasta que termine la carga por defecto.....
                Enabled = false;
                //.............................................................

                g_obj_Funciones_Paginador = new Funciones_Paginador();
            }
            catch (Control_Errores)
            {
                g_bol_ConstructorPantalla_Terminado_Correctamente = false;
            }
            catch (Exception ex)
            {
                g_bol_ConstructorPantalla_Terminado_Correctamente = false;

                Control_Errores.Errores_Log("", ex, nameof(P_Configuraciones) + "/" + nameof(P_Configuraciones));
            }
            finally
            {
                //Bloquear pantalla hasta que termine la carga por defecto .............
                Enabled = true;
                //......................................................................
            }
        }
        #endregion

        #region Inicio de pantalla
        private void P_Configuraciones_Load(object sender, EventArgs e)
        {
            try
            {
                //Configurar el Timer para Paginacion ###############################################################
                g_timer_Paginar.Interval = 1000;
                g_timer_Paginar.Tick += delegate (object s, EventArgs ee)
                {
                    g_timer_Paginar.Stop();
                    try
                    {
                        g_obj_Controladora.RecargarDatos();
                    }
                    catch (Control_Errores)
                    {
                        Mensajes.MostrarMensaje(Mensajes.G_STR_MENSAJES_GENERAL_ERROR_CARGARDATOSPANTALLA());
                        Salir_P_Base();
                    }

                };
            }
            catch (Exception ex)
            {
                //No se muestra mensaje pero se guarda en el log
                Control_Errores.Errores_Log("", ex, nameof(P_Configuraciones) + "/" + nameof(P_Configuraciones_Load));

                g_bol_ConstructorPantalla_Terminado_Correctamente = false;
            }
        }

        private void P_Configuraciones_Shown(object sender, EventArgs e)
        {
            try
            {
                if (g_bol_ConstructorPantalla_Terminado_Correctamente)
                {
                    // Si el Tipo de Apertura de Pantalla es Añadir(g_int_tipoAperturaPantalla = 0), se desactivan los botones correspondientes
                    // Añadir
                    if (this.P_Base_TipoAperturaPantalla == 0)
                    {
                        P_Base_TituloPantalla = P_Base_TituloPantalla + " - Añadir";

                        g_obj_Controladora.g_bol_Termino_CargaDatos_Inicial = true;

                        ActivarBotones(false);

                        //Poner Texto predeterminado y foco
                        if ((P_Base_Campo_1 != null && P_Base_Campo_1.Trim().Length > 0) ||
                            (P_Base_Campo_2 != null && P_Base_Campo_2.Trim().Length > 0))
                        {
                            if (P_Base_Campo_1 != null && P_Base_Campo_1.Trim().Length > 0)
                            {
                                ex_txt_P_Configuraciones_Cadencia_SincronizacionAutomatica.Text = P_Base_Campo_1;
                            }
                            if (P_Base_Campo_2 != null && P_Base_Campo_2.Trim().Length > 0)
                            {
                                ex_txt_P_Configuraciones_Cadencia_SincronizacionAutomatica.Exferia_TextBox_Foco();
                            }
                        }
                        else
                        {
                            ex_txt_P_Configuraciones_Cadencia_SincronizacionAutomatica.Exferia_TextBox_Foco();
                        }
                        g_obj_Controladora.g_bol_Termino_CargaDatos_Inicial = false;

                    }
                    //Modificar
                    else
                    {
                        ActivarBotones(true);

                        //Paginacion
                        if (P_Base_PantallaOrigen != null &&
                           P_Base_PantallaOrigen.P_Base_Objetos_Filtrados != null &&
                           P_Base_PantallaOrigen.P_Base_Objetos_Filtrados.Count > 0)
                        {
                            g_obj_Funciones_Paginador.Listado_ARecorrer(P_Base_PantallaOrigen.P_Base_Objetos_Filtrados.ToList(), 1);

                            // Asignando las paginas totales
                            Exferia_Paginador_Configuracion.PaginasTotales = g_obj_Funciones_Paginador.Numero_Paginas_Totales;
                        }
                        else
                        {
                            Exferia_Paginador_Configuracion.Visible = false;
                        }

                        g_obj_Controladora.RecargarDatos();
                    }
                }
                else
                {
                    Mensajes.MostrarMensaje(Mensajes.G_STR_MENSAJES_GENERAL_ERROR_CARGARDATOSPANTALLA());
                    Salir_P_Base();
                }
            }
            catch (Control_Errores)
            {
                Mensajes.MostrarMensaje(Mensajes.G_STR_MENSAJES_GENERAL_ERROR_CARGARDATOSPANTALLA());
                Salir_P_Base();
            }
            catch (Exception ex)
            {
                //No se muestra mensaje pero se guarda en el log
                Control_Errores.Errores_Log("", ex, nameof(P_Configuraciones) + "/" + nameof(P_Configuraciones_Shown));

                Mensajes.MostrarMensaje(Mensajes.G_STR_MENSAJES_GENERAL_ERROR_CARGARDATOSPANTALLA());
                Salir_P_Base();
            }
        }

        public void ActivarBotones(bool _bol_Activar)
        {
            if (Exferia_Paginador_Configuracion.Visible)
            {
                Exferia_Paginador_Configuracion.Visible = _bol_Activar;
            }

            if (ex_btn_P_Configuraciones_Borrar.Enabled)
            {
                ex_btn_P_Configuraciones_Borrar.Enabled = _bol_Activar;
            }
        }
        #endregion

        #region Botones Grabar, Borrar, BuscarCodigoSiguiente, Generar Clave, Borrar Clave
        private void ex_btn_P_Terminales_Grabar_Click(object sender, EventArgs e)
        {
            Grabar();
        }
        private void Grabar()
        {
            if ( //Añadir
                (P_Base_TipoAperturaPantalla == 0 && Datos_Generales.Permisos_Comprobar(g_mdl_PRV_OpcionesDetalle.opcion, g_lst_INTERNO_Permisos_Modelo, (int)G_ENUM_PERMISOS.Anadir, true)) ||
                //Modificar
                (P_Base_TipoAperturaPantalla != 0 && Datos_Generales.Permisos_Comprobar(g_mdl_PRV_OpcionesDetalle.opcion, g_lst_INTERNO_Permisos_Modelo, (int)G_ENUM_PERMISOS.Modificar, true)))
            {
                g_obj_Controladora.GrabarDatos(true);
            }
        }

        private void ex_btn_P_Terminales_Borrar_Click(object sender, EventArgs e)
        {
            Borrar();
        }
        private void Borrar()
        {
            if (Datos_Generales.Permisos_Comprobar(g_mdl_PRV_OpcionesDetalle.opcion, g_lst_INTERNO_Permisos_Modelo, (int)G_ENUM_PERMISOS.Borrar, true))
            {
                g_obj_Controladora.BorrarDatos(true);
            }
        }
        #endregion

        #region Eventos del paginador
        protected void ctu_Paginacion_Primera_Click(object sender, EventArgs e)
        {
            if (g_obj_Controladora.ComprobarCambios()) //Si no han habido contratiempospasamos a la pagina indicada
            {
                if (g_obj_Funciones_Paginador.Primera())
                {
                    //Asignando al control la pagina actual.
                    Exferia_Paginador_Configuracion.PaginaActual = g_obj_Funciones_Paginador.GetPaginaActual();

                    //Refrescamos el listado a mostrar en el form
                    P_Base_id = g_obj_Funciones_Paginador.Objeto_Devuelto.FirstOrDefault().ID;

                    g_timer_Paginar.Stop();
                    g_timer_Paginar.Start();
                }
            }
        }

        private void ctu_Paginacion_Anterior_Click(object sender, EventArgs e)
        {
            if (g_obj_Controladora.ComprobarCambios()) // si no han habido contratiempos pasamos a la pagina indicada
            {
                if (g_obj_Funciones_Paginador.Anterior())
                {
                    //Asignando al control la pagina actual.
                    Exferia_Paginador_Configuracion.PaginaActual = g_obj_Funciones_Paginador.GetPaginaActual();

                    //Refrescamos el listado a mostrar en el form
                    P_Base_id = g_obj_Funciones_Paginador.Objeto_Devuelto.FirstOrDefault().ID;

                    g_timer_Paginar.Stop();
                    g_timer_Paginar.Start();
                }
            }
        }

        protected void ctu_Paginacion_Siguiente_Click(object sender, EventArgs e)
        {
            if (g_obj_Controladora.ComprobarCambios()) // Si no han habido contratiempos pasamos a la pagina indicada
            {

                if (g_obj_Funciones_Paginador.Siguiente())
                {
                    // Asignando al control la pagina actual.
                    Exferia_Paginador_Configuracion.PaginaActual = g_obj_Funciones_Paginador.GetPaginaActual();

                    // Refrescamos el listado a mostrar en el form.
                    P_Base_id = g_obj_Funciones_Paginador.Objeto_Devuelto.FirstOrDefault().ID;

                    g_timer_Paginar.Stop();
                    g_timer_Paginar.Start();
                }
            }
        }

        protected void ctu_Paginacion_Ultima_Click(object sender, EventArgs e)
        {
            if (g_obj_Controladora.ComprobarCambios()) // Si no han habido contratiempos pasamos a la pagina indicada
            {
                if (g_obj_Funciones_Paginador.Ultima())
                {
                    // Asignando al control la pagina actual.
                    Exferia_Paginador_Configuracion.PaginaActual = g_obj_Funciones_Paginador.GetPaginaActual();

                    // Refrescamos el listado a mostrar en el form.
                    P_Base_id = g_obj_Funciones_Paginador.Objeto_Devuelto.FirstOrDefault().ID;

                    g_timer_Paginar.Stop();
                    g_timer_Paginar.Start();
                }
            }
        }

        protected void txt_PaginaActual_KeyPress(object sender, KeyPressEventArgs e)
        {
            // si pulsamos Enter.
            if (e.KeyChar.Equals('\r'))
            {
                if (g_obj_Controladora.ComprobarCambios()) //Si no han habido contratiempos pasamos a la pagina indicada
                {
                    //Asignamos a la paginacion el valor del textbox
                    g_obj_Funciones_Paginador.SetPaginaActual(Exferia_Paginador_Configuracion.txt_ValorPaginaActual - 1);

                    //Asignamos al control la pagina actual
                    Exferia_Paginador_Configuracion.PaginaActual = g_obj_Funciones_Paginador.GetPaginaActual();

                    //Regrescamos el listad a mostrar en el form.
                    P_Base_id = g_obj_Funciones_Paginador.Objeto_Devuelto.FirstOrDefault().ID;

                    g_timer_Paginar.Stop();
                    g_obj_Controladora.RecargarDatos();
                }
            }
        }
        #endregion

        #region Teclas de acceso rapido
        protected override bool ProcessCmdKey(ref Message msg, Keys keyData)
        {
            // Salir sin Seleccionar
            if (keyData == Keys.F10)
            {
                Salir_P_Base();
                return true;
            }
            // Grabar
            else if (keyData == Keys.F2)
            {
                Grabar();
                return true;
            }
            // Borrar
            else if (keyData == Keys.F5)
            {
                Borrar();
                return true;
            }
            return base.ProcessCmdKey(ref msg, keyData);
        }
        #endregion

        #region Controlar si se modifica algo
        private void Controlar_Modificaciones_TextBox_TextChanged(object sender, EventArgs e)
        {
            Controlar_Modificaciones();
        }

        private void Controlar_Modificaciones_RadioButton_CheckedChanged(object sender, EventArgs e)
        {
            Controlar_Modificaciones();
        }

        private void Controlar_Modificaciones_CheckBox_CheckedChanged(object sender, EventArgs e)
        {
            Controlar_Modificaciones();
        }

        private void Controlar_Modificaciones()
        {
            if (Enabled && g_obj_Controladora != null && g_obj_Controladora.g_bol_Termino_CargaDatos_Inicial)
            {
                P_Base_SeModificoDatosPantalla = true;
            }
        }

        #endregion
    }
}
